#!/usr/bin/env python
# -*- coding: euc-jp -*-

"""
    \file BufferBase.py
    \brief Buffer abstract class
    \date $Date: 2007/09/12 $
    \author Noriaki Ando <n-ando@aist.go.jp> and Shinji Kurihara

 Copyright (C) 2006
     Noriaki Ando
     Task-intelligence Research Group,
     Intelligent Systems Research Institute,
     National Institute of
         Advanced Industrial Science and Technology (AIST), Japan
     All rights reserved.
"""

class BufferBase:
	
	"""
	\if jp
	\class BufferBase
	
	ΥХåեΤݥ󥿡ե饹
	ݥХåե饹ϡʲν貾۴ؿμ󶡤ʤФʤʤ
	
	public󥿡եȤưʲΤΤ󶡤롣
	- write(): Хåե˽񤭹
	- read(): Хåեɤ߽Ф
	- length(): ХåեĹ֤
	- isFull(): ХåեդǤ
	- isEmpty(): ХåեǤ
	
	protected󥿡եȤưʲΤΤ󶡤롣
	- put(): Хåե˥ǡ񤭹
	- get(): Хåեǡɤ߽Ф
	
	\param DataType Хåե˳Ǽǡ
	
	\else
	\class BufferBase
	\brief BufferBase abstract class
	
	This is the abstract interface class for various Buffer.
	
	\param DataType Data type to be stored to the buffer.
	
	\endif
	"""
	def __init__(self):
		pass


	def length(self):
		"""
		\if jp
		\brief ХåեĹ
		\else
		\brief Get the buffer length
		\endif
		"""
		pass


	def write(self, value):
		"""
		\if jp
		\else Хåե˥ǡ񤭹
		\brief Write data into the buffer
		\endif
		"""
		pass


	def read(self, value):
		"""
		\if jp
		\brief Хåեǡɤ߹
		\else
		\brief Read data from the buffer
		\endif
		"""
		pass


	def isFull(self):
		"""
		\if jp
		\brief ХåեfullǤ
		\else
		\brief True if the buffer is full, else false.
		\endif
		"""
		pass


	def isEmpty(self):
		"""
		\if jpwork/OpenRTM-aist-0.2.0-Python/OpenRTM/
		\brief ХåեemptyǤ
		\else
		\brief True if the buffer is empty, else false.
		\endif
		"""
		pass


	def put(self, data):
		"""
		\if jp
		\brief Хåե˥ǡ񤭹
		\else
		\brief Write data into the buffer
		\endif
		"""
		pass


	def get(self):
		"""
		\if jp
		\brief Хåեǡ
		\else
		\brief Get data from the buffer
		\endif
		"""
		pass


	def getRef(self):
		"""
		\if jp
		\brief ˽񤭹ХåեλȤ
		\else
		\brief Get the buffer's reference to be written the next
		\endif
		"""
		pass



class NullBuffer(BufferBase):
	
	def __init__(self, size=None):
		if size == None:
			size=1
		self._length = 1
		self._data = None
		self._is_new = False
		self._inited = False


	def init(self, data):
		self.put(data)


	def clear(self):
		self._inited = False


	def length(self):
		return 1


	def write(self, value):
		self.put(value)
		return True


	def read(self, value):
		if not self._inited:
			return False
		value[0] = self.get()
		return True


	def isFull(self):
		return False


	def isEmpty(self):
		return not self._inited


	def isNew(self):
		return self._is_new


	def put(self, data):
		self._data = data
		self._is_new = True
		self._inited = True


	def get(self):
		self._is_new = False
		return self._data


	def getRef(self):
		return self._data
